Releases von JaFuffy
====================

Version 0.6.0 (01/2019)
-----------------------

* Aktualisierung auf neuere Versionen von Java, Launch4j und IzPack.
* Start eines Prototyps fürs Spielen über ein lokales Netzwerk.
* Entfernung von Speicherlecks
* Vereinfachung der Umsetzung der Turniersteuerung
* Überarbeitung des 3D-Balkendiagramms
* Verbesserungen bei der Eingabe der Spielernamen (Längenbeschränkung)
* Kleinere Fehlerbehebungen


Version 0.5.4 (05/2017)
-----------------------

* Tool-Tipps werden für Zwischenstand und Balkendiagramm immer angezeigt, auch wenn die 
  Eigenschaft ausgeschaltet ist. Das Verhalten ist wie bei der Punktetabelle.
* Einführung von Java-Web-Start, dabei Entfernung der Applet-Technologie.
* Leichte Layout-Überarbeitungen der Benutzeroberfläche.
* Bei einem Erststart oder einem Lauf als Java-Web-Start-Anwendung wird Haupt-Fenster initial
  zentriert am Bildschirm angezeigt.
* Überarbeitung der Installation unter Linux.


Version 0.5.3 (04/2017)
-----------------------

* Überarbeitung der Darstellung der Bestenlisten
* Überarbeitung der Anzeige des Zwischenstandes
* Verbesserung des räumlichen Balkendiagramms zur Darstellung des Turnierverlaufs, inklusive
  räumliche Drehung, Vergrößerung und Verschiebung.
* Speichern und Laden von Turnier überarbeitet: Datenmodell aufgeräumt. Dadurch werden zum einen
  die Dateien kleiner, zum anderen wird die Langzeitstabilität des Speicherformats verbessert.


Version 0.5.2 (05/2016)
-----------------------

* Erweiterung der Anleitung (Spielstärken, Paschauswahlregeln)
* "Speicher unter" erhält zunächst die Beschreibung.  Bei erneuter Auswahl desselben
  Speicherschachtes wird die automatische erzeugte Beschreibung eingefügt.
* Bestenliste grafisch etwas aufgewertet.
* Überarbeitung der Erstellung des Reports.
  - Überarbeitung der Darstellung des Turnierverlaufs.
  - Einführung einer tabellarischen Auflistung des Turnierverlaufs.
  - Überarbeitung der Verlaufsgrafik (Balkendiagramm) begonnen.
* Verbesserung der Pasch-Prognose, genutzt von Bots und als Vorschlag für Spieler.
* Einführung von Bot-Spielstärken:
  - Einstellung der Spielstärke der Bots, zugeordnet zu einem Botnamen.
  - Erweiterte Namensauswahl bei Bot zur Verwendung einer Spielstärke.
* Bauumgebung aktualisiert und an IzPack 5 angepasst.
* Verbesserung von Hilfetexten.
* Optimierung der Würfelauswahl bei der kleinen Straße: Bei Im-Hieb-Variante bei Erreichen nicht
  mehr weiterwürfeln.
* Korrekturen zur Im-Hieb-Erkennung, kleineres Darstellungsproblem bei Im-Hieb-Nachricht
  behoben.
* Refaktorierung zur Vereinfachung von Auswahl, Auswertung und Analyse.
* Überarbeitung des Balkendiagramms zum Gesamtstand. Grafisch etwas aufgewertet. Kontexthilfe
  gibt Namen des Spielers auch bei Punktzahlen an. Kleinere Fehlerkorrekturen bezüglich der
  Darstellung, beispielsweise bessere Berücksichtigung von Schriftgrößen.


Version 0.5.1 (02/2016)
-----------------------

* Bots berücksichtigen jetzt auch die Im-Hieb-Regeln.
* Berücksichtigt bei der Rücknahme, ob ein menschlicher Spieler dies anfordert. 
  Bots können kein Setzen rückgängig machen.
* Menüeinträge "Setzen" und "Vorschlagen" nicht mehr mit abweichendem Stil dargestellt.
* In der Anleitung bei den Hinweisen zu den Bewertungen von Würfen Literaturhinweise gegeben.
* In der Anleitung Präzisierung der Spielregeln.
* Refaktorierung des Quelltextes zur weiteren Vereinfachung.


Version 0.5.0 (01/2016)
------------------------

* Einführung von Bots, welche die Rolle von Mitspielern übernehmen.
* Überarbeitung der Icons.
* Kontinuierliche Verbesserung der Implementierung.
* Kleinere Fehlerkorrekturen, z.B.:
  - Fehlfunktion nach Turnierende bei Nimbus-Oberfläche behoben.
  - Kontexthilfe bei Absprache der Turnierbedingungen


Version 0.4.9 (10/2015)
-----------------------

* Korrektur der Reaktion auf die Sicherheitsabfrage zum Programmende. Zuvor wurde JaFuffy immer beendet.
* Korrektur des Neustartverhaltens.
* Korrektur der automatischen Fenstergrößenanpassung bei Änderung der Spieleranzahl im Turnier.
* Umstieg auf IzPack 5 (Erzeugung einer Installation) und damit einhergehenden Verbesserungen der Installation.
* Verbesserung der Entwicklungsinfrastruktur (z.B. Bausystem).
* Verbesserungen in der Implementierung, Refaktorierung.
* Strukturverbesserungen für Schritte in Richtung Android. 


Version 0.4.8 (03/2015)
-----------------------

* Ein Turnier kann auch gestartet werden, wenn nach Programmstart auf die freie Fläche geklickt
  wird, in der eine Begrüßungsgrafik oder ein Begrüßungstext gezeigt wird.
* Als Standard-Look&Feel wird Nimbus angesehen. 
* Kontextmenüeintrag zum Werfen aller Würfel funktioniert wieder.


Version 0.4.7 (02/2015)
-----------------------

* Bessere Unterstützung von Nimbus (Look & Feel).
* Auslieferung mit "JGoodies Looks".
* Extras-Menü um Neustart erweitert.
* Überarbeitung einiger Elemente der Bedienoberfläche (z.B. für die Absprache und die 
  Fortsetzung), etwa eine großzügigere räumliche Gestaltung oder eine konsistente Anordnung
  von Bedienelementen.
* Natives Windows-Installationsprogramm, erstellt mittels "Launch4j".
* Fehler bei der Aktualisierung der Zeilenhöhe in der Punktetabelle nach Fortsetzung eines
  Turniers korrigiert.


Version 0.4.6 (01/2015)
----------------------

* Berechnung der minimalen Spaltenbreite in der Punktetabelle verbessert. Jetzt wird ein Minimum
  eingehalten, so dass die Breite auch für kurze Namen passt.
* Kleinere grafische Verbesserungen in der Tabellendarstellung hinsichtlich Abständen. 
* Einträge im Menü zur Auswahl vom Look & Feel sind jetzt alphabetisch sortiert. 
* JaFuffy erkennt jetzt wieder, ob es schon zuvor gestartet war. Bei weiteren Starts wird von
  JaFuffy ein Mehrfachstart gemeldet, dann bleibt nur die Möglichkeit, das Programm zu beenden. 
* Die Würfelauswahl funktioniert jetzt auch für das Look & Feel "Nimbus" korrekt. Zuvor 
  funktionierte das Roll-Over nicht richtig. Berührte der Mauszeiger einen Würfel, wurde er 
  teilweise nicht richtig neue gezeichnet. 
* Erster Prototyp zur Unterstützung von mitgelieferten Look & Feel, die nicht vom System 
  unterstützt werden. Beispielhaft wird jetzt das Look & Feel "Kunststoff" ausgeliefert.
* Kleinere Korrekturen der Installation.  


Version 0.4.5 (01/2015)
----------------------

* Tipps werden nun durch eine Prozentzahl bewertet.
* Bei Tipps stimmt die Feldumrahmung jetzt mit Würfelselektierung überein, war zuvor fehlerhaft.
* Erweiterung der Prognosen ("Tipps") um kleine Straße. Dadurch ist die Prognose vollständig.
* Verbesserung der Prognosen durch eine vereinfachte Berücksichtigung des Bonus.
* Neuer Menüeintrag "Vorschlag setzen"
* Mit den Tasten "W" (würfeln), "V" (Vorschlag geben lassen) und "T" (Vorschlag setzen) kann man 
  erreichen, dass sich JaFuffy als Computer-Gegenspieler verhält.
* Überarbeitung der Anleitung (Nachweise von Rechten, Entstehungsgeschichte, Korrekturen von 
  Links, Korrekturen von schlecht verständlichen falschen Passagen, Verständlichkeit, etc.)
* Modernisierung der HTML-Seiten (sowohl Quelltext als auch Aussehen)
* Kleinere grafische Überarbeitungen von JaFuffy (Icons, Logos, Bilder, etc.)
* Korrekturen für Applet-Betrieb
* Überarbeitung des Intros
* Überarbeitung der Installation, Berücksichtigung von Java 8
* Überarbeitung des Größenänderungsverhaltens der Tabelle, hin zum robusteren Verhalten.
* "Autostart Editieren auf Tabelle" ist jetzt deaktiviert. Machte sich zuvor bemerkbar, wenn
  ein Zug zurückgenommen wurde, und gleich eine weitere Taste gedrückt wurde.
* Umstellung auf die GPL in der Version 3
* Interne Refaktorierung (Verwendung neuer Java-Sprachkonstrukte, Strukturverbesserungen, 
  Bezeichnungen, Vereinfachungen, Einführung von Konstantennamen, Befolgung von Richtlinien, 
  etc.)
* Einführung von Checkstyle (Überprüfung des Quelltextes)
* Erste kleine Schritte in Richtung Android


Version 0.4.4 (05/2012)
----------------------

* Zwischenstandsanzeige hinzugefügt
* Menüstruktur geändert
* Hervorhebung der Setzvorschläge verbessert
* Tabellendarstellung verbessert
* Kontexthilfen korrigiert
* Hilfedatei aktualisiert
* Fehlerkorrektur bei der Auswahl des Spielbeginners
* Fehlerkorrekturen bei der Speicherung und Fortsetzung von Turnieren
* Interne Tabellendarstellungsberechung verbessert
* Interne Handhabung von Regelvarianten verbessert
* Interne Arbeitsteilung zwischen Tabellenmodell und -darstellung verbessert
* Internes Nachrichtensystem über Zustandsänderungen der Würfel verbessert


Version 0.4.3 (05/2012)
-----------------------

* Titel in Fenstern und Dialogen überarbeitet
* Fokussystem der Benutzeroberfläche überarbeitet
* Entfernung der Policy-Datei (wurde nur zur Entwicklung benötigt)
* Würfeln und Würfelauswahl ist nun auch per Tastatur möglich.
* Große Straße ist in das Verfahren der Setztipps mit aufgenommen worden.


Version 0.4.2 (04/2011)
-----------------------

* Umstrukturierung der Projektstruktur zur Anpassung an Eclipse-Philosophie
* Umstellung des Baus mittels Ant unter Eclipse
* Installation bringt wahlweise Quellen samt Entwicklungsumgebungseinstellungen mit sich
* Neue Version des Software-Installers IzPack und Überarbeitung der IzPack-Installation
* Debian-Paketbau überarbeitet, portabel gestaltet
* Fensterlogo eingeführt
* Überarbeitung der internen Klassenstruktur, Benutzung neuerer Java-Konstrukte
* Überarbeitung des internen Nachrichtensystems
* Überarbeitung des UI Layouting (robuster gegenüber verschiedenen Look&Feel, besonders Nimbus)
* Überarbeitung des Fortsetzen-Dialogs
* Automatische Sicherungsdatei wird entfernt, falls das Turnier beendet wird.
* Lizenzdialog erweitert


Version 0.4.1 (02/2009)
-----------------------

* Willkommenseinstieg bei Erststart überarbeitet
* Automatische Suche nach neuerer Version bei Programmstart möglich
* Bei Würfelbildern Ecken abgerundet (Transparenz im Button)
* Buttons zur Würfelauswahl überarbeitet (robust gegen Look & Feel Varianten)
* Icons für Menüs und Desktops für Windows und Linux-Varianten
* Überwachung, ob JaFuffy versehentlich mehrfach gestartet wurde


Version 0.4.0 (02/2009)
-----------------------

* Überarbeitung des Quelltextes. Er ist übersichtlicher geworden,
  einige umständliche Konstrukte sind weggefallen.
* Ein erster Algorithmus für das Geben von Setztipps ist vorhanden. Damit
  sollen zur Verbesserung Erfahrungen gesammelt werden. Insbesondere sind die
  Benutzeroberfläche angepasst sowie einige interne Datenstrukturen eingeführt
  worden.
* Die Toneffekte sind in der Lautstärke angehoben worden.
* Die Balkengrafik für den Spielverlauf ("Report") ist in der Handhabung
  überarbeitet worden.
* Überarbeitung der Anleitung, insbesondere ergänzend eine kurze Beschreibung
  zur Berechnung der Setztipps.
* Neuer Hotkey "a" für "Fenster anpassen"
* Der Eintrag "setzen" im Kontextmenü vom Punktezettel funktioniert jetzt für
  Setzen sowohl durch Einfachklick als auch durch Doppelklick.
* Bei der Aufnahme in die Bestenliste kann ein Kommentar eingegeben werden.
  Bislang war auch ein Abbruch möglich, was aber nur verwirrend war. Jetzt
  kann nur noch bestätigt werden.
* Initialisierung des Soundsystems konservativer gestaltet.
* Überarbeitung des Algorithmus zur Erstellung der Bestenliste.
* Überarbeitung der Serialisierung (Speicherung des Turnierstandes).
* Überarbeitung der Look & Feel - Anpassung.
* Überarbeitung der Farbgestaltung
* Überarbeitung des UI Layouting und der Look & Feel Unterstützung
* Frage nach Fensteranpassung bei Look & Feel Änderung
* Suche nach neuen Versionen auf Homepage
* Installationsmöglichkeiten verbessert


Version 0.3.4 (06/2001)
-----------------------

* Jetzt kann nicht mehr während Meldungen wie "Bonus" oder "Joker" gewürfelt
  oder gesetzt werden.
* Bei Fortsetzung eines nicht automatisch gesicherten Turnierstands wird der
  aktuelle Turnierstand (falls vorhanden) automatisch gesichert.


Version 0.3.3a (04/2001)
------------------------

* erste veröffentlichte Version (mit Lauffähigkeit direkt aus dem Internet)


Version 0.3.3 (04/2001)
-----------------------

* Fehler bei Berechnung der Standardabweichung bereinigt
* Fehler im Fortsetzungsdialog bereinigt
  - jetzt korrekte Textanzeige
  - jetzt korrekte Anzeige der Würfel nach Fortsetzung der automatischen
    Sicherung
* Anleitung für Einbindung in Web-Seite vorbereitet
* erste veröffentlichte Version


Version 0.3.2 (04/2001)
-----------------------

* Anleitung überarbeitet
* Verbesserung der Balkengrafik inklusive Zoom
* interne Versionsabfrage der benötigten Java-Pakete


Version 0.3.1 (02/2001)
-----------------------

* Regelvariante im Fenstertitel
* Besseres Verfahren zum Speichern des Turnierstands


Version 0.3.0 (12/2000)
-----------------------

* Lauffähigkeit als Applet
  (nur für Internet Explorer und Netscape Navigator mit Plugin)
* Fehlerausgabe mit Methode "printStackTrace"
* Überarbeitung der Geräusche (u.a. bei Applikation abschaltbar)
* Überarbeitung der Anleitung


Version 0.2.2
-------------

* Eingangssequenz (Iteriertes Funktionensystem)
* "LIESMICH.txt" erstellt


Version 0.2.1
-------------

* Einführungsdialog beim erstmaligen Programmstart
* (De)Installationshinweise
* kleinere Überarbeitung einiger Dialoge


Version 0.2.0
-------------

* Erstmalige Erstellung eines JaFuffy-Pakets
* Setzen kann zurückgenommen werden


Version 0.1.x
-------------

* Entwicklungsversion


Version 0.0.x
-------------

* Versuchsversion
